# DB QUERY EDITOR

A module providing an SQL database query editor. The library depends on Monaco editor and Angular Material.

## Components

*  Db-explorer: 

    The hierarchical tree of the database server.

*  Query area:

    Tabs of queries where the users writes his query before execution.

    For Now, each tab corresponds to a specific database.

*  Result viewer:

    Display of the query result.

*  Toolbar:

    A toolbar containing the execute "button".

## Input


## Setup

to use the ngx-query-editor library follow these instructions: 

1. Run `npm i ngx-query-editor`.
2. In modules.ts `{ NgxQueryEditorModule, NgxQueryEditorAbstractService } from 'ngx-query-editor';` and add `NgxQueryEditorModule` to the imports array. 
3. Implement the `NgxQueryEditorAbstractService`.
4. In modules.ts provide the abstract service and use class your implemented service `  providers: [
                                                                                        { provide: NgxQueryEditorAbstractService, useClass: NgxQueryEditorService},
                                                                                        ]`
5. Install angular material by running `npm install --save @angular/material @angular/cdk @angular/animations`
6. Install ngx-monaco-editor by running `npm i ngx-monaco-editor`
7. Install monaco-editor by running `npm i monaco-editor`
8. In angular.json add `{ "glob": "**/*", "input": "node_modules/ngx-monaco-editor/assets/monaco", "output": "./assets/monaco/" }` under the following path "projects"/"{project_name}"/"architect"/"build"/"options"/"assets" 
   
   as the following:
`             "assets": [

              "src/favicon.ico",

              "src/assets",

              { "glob": "**/*", "input": "node_modules/ngx-monaco-editor/assets/monaco", "output": "./assets/monaco/" }
              
            ],`   

9. In modules.ts, `import { BrowserAnimationsModule } from '@angular/platform-browser/animations';` and add it to imports array.
10. In your application's html call the component using `<lib-ngx-query-editor></lib-ngx-query-editor>`.
11. in index.html add the Angular Material icons registries `<link href="https://fonts.googleapis.com/icon?family=Material+Icons" rel="stylesheet">` and `<link href="https://fonts.googleapis.com/css?family=Roboto:300,400,500" rel="stylesheet">`.
12. To use one of angular's prebuilt themes, in styles.scss add the following code `@import "~@angular/material/prebuilt-themes/indigo-pink.css";`.
13. To style the context menu in the db-explorer, in styles.scss add the following code `.custom-menu-content{div{padding: 0 !important;}}`.
14. To fix the db-explorer overlay, add the following code inapp.component.scss `:host{flex: 1 1 auto;display: flex;flex-flow: column nowrap;lib-ngx-query-editor{flex: 0 0  600px;}.filler {flex: 1 1 auto;}}` and modify as desired.
    
### Known issues during Setup:

* ` export '' was not found in '@angular/core' since v8.0.0-beta.12 ` may occur because of incompatibility of the angular environment, it can be fixed by uninstalling and installing angular/core by running : `npm uninstall @angular/core` then `npm install -S @angular/core`.
* `NullInjectorError: No provider for ViewportScroller. `  can be caused by the uninstalling and installing angular/core which can be resolved by updating angular/cli and angular/core in the entire project by running `ng update @angular/cli @angular/core`.
* `"Errors: Data path “.builders['app-shell']” should have required property 'class'" `  can be caused updating angular/cli and angular/core which can be resolved by changing the devkit buikder in package.json from `"@angular-devkit/build-angular": "^0.800.1"` to `"@angular-devkit/build-angular": "^0.10.0"`.