import { OnInit, EventEmitter } from '@angular/core';
import { NestedTreeControl } from '@angular/cdk/tree';
import { ServerNode, SqlServerModel } from '../ngx-query-editor.models';
import { Observable } from 'rxjs';
import { NgxQueryEditorAbstractService } from '../ngx-query-editor.abstract.service';
import { MatTreeNestedDataSource } from '@angular/material/tree';
import { MatMenuTrigger } from '@angular/material';
export declare class DbExplorerComponent implements OnInit {
    private queryEditorService;
    treeControl: NestedTreeControl<ServerNode>;
    dataSource: MatTreeNestedDataSource<ServerNode>;
    contextMenu: MatMenuTrigger;
    contextMenuPosition: {
        x: string;
        y: string;
    };
    newQueryTab: EventEmitter<string>;
    stateEmitter: EventEmitter<boolean>;
    serverSchema$: Observable<any[]>;
    serverModel$: Observable<SqlServerModel>;
    serverName: string;
    private serverTree;
    emptyState: boolean;
    onContextMenu(event: MouseEvent, item: ServerNode): void;
    constructor(queryEditorService: NgxQueryEditorAbstractService);
    onOpenInEditor($event: any, nodeName: string): void;
    hasChild: (_: number, node: ServerNode) => boolean;
    ngOnInit(): void;
    onClick(node: ServerNode): void;
    onRefreshClick(): void;
    checkEmptyState(): boolean;
    ResolveIcon(node: ServerNode): string;
}
